#!/bin/bash
#

proxy_list="proxy.list"

function fparse
{
	prx=$1
	prot=$2
	tim=$3
	pstr=$4
	pstr=$(echo "$pstr" | sed "s/[!{,}<> ]/\n/g")
	pstr=$(echo "$pstr" | sed "s/[:\"]/ /g")
	pstr=$(echo "$pstr" | sed "/countryCode/d")
	#echo "$pstr"
	country=$(echo "$pstr" | awk '/country/{print($2)}')
	status=$(echo "$pstr" | awk '/status/{print($2)}')
	regionName=$(echo "$pstr" | awk '/regionName/{print($2)}')
	if [ "$status" = "success" ]; then
		echo -e "$prx $prot $status $tim $country $regionName"
	fi
}

function fproxy
{
	pr=$1
	num=$2
	sout=""
	#
	prot="http"
	start=$(date +%s)
	str=$(curl -s --max-time 10 -x $pr -U YOURUSER:YOURPASS ip-api.com/json;echo)
	end=$(date +%s)
	sz=${#str}
	if(((sz > 8))); then
		diff=$(( end - start ))
		str=$(fparse $pr $prot $diff $str)
		sout=$(echo "$sout$str\n")
	fi
	#
	prot="https"
	start=$(date +%s)
	str=$(curl -s --max-time 10 -x https://$proxy -U YOURUSER:YOURPASS ip-api.com/json;echo)
	end=$(date +%s)
	sz=${#str}
	if(((sz > 8))); then
		diff=$(( end - start ))
		str=$(fparse $pr $prot $diff $str)
		sout=$(echo "$sout$str\n")
	fi
	#
	prot="socks4"
	start=$(date +%s)
	str=$(curl -s --max-time 10 --socks4 $proxy ip-api.com/json;echo)
	end=$(date +%s)
	sz=${#str}
	if(((sz > 8))); then
		diff=$(( end - start ))
		str=$(fparse $pr $prot $diff $str)
		sout=$(echo "$sout$str\n")
	fi
	#
	prot="socks4a"
	start=$(date +%s)
	str=$(curl -s --max-time 10 --socks4a $proxy -U YOURUSER:YOURPASS ip-api.com/json;echo)
	end=$(date +%s)
	sz=${#str}
	if(((sz > 8))); then
		diff=$(( end - start ))
		str=$(fparse $pr $prot $diff $str)
		sout=$(echo "$sout$str\n")
	fi
	#
	prot="socks5"
	start=$(date +%s)
	str=$(curl -s --max-time 10 --socks5 $proxy -U YOURUSER:YOURPASS ip-api.com/json;echo)
	end=$(date +%s)
	sz=${#str}
	if(((sz > 8))); then
		diff=$(( end - start ))
		str=$(fparse $pr $prot $diff $str)
		sout=$(echo "$sout$str\n")
	fi
	sz=${#sout}
	if(((sz > 8))); then
		echo "$num:"
		echo -e "$sout"
	fi
}

clear
echo ""
((cnt = 1))
for proxy in `cat $proxy_list`
do
	fproxy $proxy $cnt &
	((cnt = cnt + 1))
done
